package rocks.zipcode.io.quiz3.arrays;

import java.util.stream.IntStream;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {
    private String[][] board;

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public TicTacToe(){

    }

    public String[] getRow(Integer value) {
        String[] row = new String[board[0].length];
        for (int i =0; i< row.length; i++){
            row[i] = board[value][i];
        }
        return row;
    }

    public String[] getColumn(Integer value) {
        String[] column = new String[board[0].length];
        for (int i =0; i< column.length; i++){
            column[i] = board[i][value];
        }
        return column;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        String[] row = getRow(rowIndex);
        for (int i = 0; i < row.length-1; i++){
            if (!row[i].equals(row[0])){
                return false;
            }
        }
        return true;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        String[] column = getColumn(columnIndex);
        for (int i = 0; i < column.length-1; i++){
            if (!column[i].equals(column[0])){
                return false;
            }
        }
        return true;
    }

    public String getWinner() {
        if (isColumnHomogeneous(0) || isRowHomogenous(0)){
            return board[0][2];
        } else if(isColumnHomogeneous(1)|| isRowHomogenous(1)){
            return board[1][1];
        } else if(isColumnHomogeneous(2) || isRowHomogenous(2)){
            return board[2][2];
        } else if(board[0][0].equals(board[1][1]) && board[0][0].equals(board[2][2])){
            return board[0][0];
        } else if(board[0][0].equals(board[0][2]) && board[0][0].equals(board[2][0])){
            return board[0][0];
        }
        return "負けろ！";
    }
}
